Index: trunk/SophyaLib/NTools/Makefile
===================================================================
--- trunk/SophyaLib/NTools/Makefile	(revision 805)
+++ trunk/SophyaLib/NTools/Makefile	(revision 824)
@@ -3,10 +3,10 @@
 all: $(LIB)libNTools.a
 clean:
-	rm -f $(OBJ)cimage.o $(OBJ)cspline.o $(OBJ)cvector.o $(OBJ)datacards.o $(OBJ)datatypes.o $(OBJ)dates.o $(OBJ)difeq.o $(OBJ)dvlist.o $(OBJ)dynccd.o $(OBJ)fct1dfit.o $(OBJ)fct2dfit.o $(OBJ)fftserver.o $(OBJ)generaldata.o $(OBJ)generalfit.o $(OBJ)hisprof.o $(OBJ)histos.o $(OBJ)histos2.o $(OBJ)imageop.o $(OBJ)integ.o $(OBJ)linfit.o $(OBJ)matrix.o $(OBJ)median.o $(OBJ)ntupintf.o $(OBJ)ntuple.o $(OBJ)outilsinit.o $(OBJ)perandom.o $(OBJ)poly.o $(OBJ)rk4cdifeq.o $(OBJ)rzimage.o $(OBJ)simplesort.o $(OBJ)tabmath.o $(OBJ)tmatrix.o $(OBJ)tvector.o $(OBJ)utils.o $(OBJ)datime.o $(OBJ)fftpackc.o $(OBJ)matxop.o $(OBJ)nbmath.o $(OBJ)nbrandom.o $(OBJ)nbtri.o $(OBJ)strutil.o
+	rm -f $(OBJ)cimage.o $(OBJ)cspline.o $(OBJ)datatypes.o $(OBJ)dates.o $(OBJ)difeq.o $(OBJ)dynccd.o $(OBJ)fct1dfit.o $(OBJ)fct2dfit.o $(OBJ)fftmserver.o $(OBJ)fftpserver.o $(OBJ)fftserver.o $(OBJ)fftservintf.o $(OBJ)generaldata.o $(OBJ)generalfit.o $(OBJ)imageop.o $(OBJ)integ.o $(OBJ)median.o $(OBJ)ntoolsinit.o $(OBJ)ntupintf.o $(OBJ)objfitter.o $(OBJ)perandom.o $(OBJ)poly.o $(OBJ)rk4cdifeq.o $(OBJ)rzimage.o $(OBJ)simplesort.o $(OBJ)tabmath.o $(OBJ)utils.o $(OBJ)datime.o $(OBJ)fftmayer_r4.o $(OBJ)fftmayer_r8.o $(OBJ)fftpackc.o $(OBJ)matxop.o $(OBJ)nbmath.o $(OBJ)nbrandom.o $(OBJ)nbtri.o
 	rm -f $(LIB)libNTools.a
-$(LIB)libNTools.a : $(OBJ)cimage.o $(OBJ)cspline.o $(OBJ)cvector.o $(OBJ)datacards.o $(OBJ)datatypes.o $(OBJ)dates.o $(OBJ)datime.o $(OBJ)difeq.o $(OBJ)dvlist.o $(OBJ)dynccd.o $(OBJ)fct1dfit.o $(OBJ)fct2dfit.o $(OBJ)fftpackc.o $(OBJ)fftserver.o $(OBJ)generaldata.o $(OBJ)generalfit.o $(OBJ)hisprof.o $(OBJ)histos.o $(OBJ)histos2.o $(OBJ)imageop.o $(OBJ)integ.o $(OBJ)linfit.o $(OBJ)matrix.o $(OBJ)matxop.o $(OBJ)median.o $(OBJ)nbmath.o $(OBJ)nbrandom.o $(OBJ)nbtri.o $(OBJ)ntupintf.o $(OBJ)ntuple.o $(OBJ)outilsinit.o $(OBJ)perandom.o $(OBJ)poly.o $(OBJ)rk4cdifeq.o $(OBJ)rzimage.o $(OBJ)simplesort.o $(OBJ)strutil.o $(OBJ)tabmath.o $(OBJ)tmatrix.o $(OBJ)tvector.o $(OBJ)utils.o
+$(LIB)libNTools.a : $(OBJ)cimage.o $(OBJ)cspline.o $(OBJ)datatypes.o $(OBJ)dates.o $(OBJ)datime.o $(OBJ)difeq.o $(OBJ)dynccd.o $(OBJ)fct1dfit.o $(OBJ)fct2dfit.o $(OBJ)fftmayer_r4.o $(OBJ)fftmayer_r8.o $(OBJ)fftmserver.o $(OBJ)fftpackc.o $(OBJ)fftpserver.o $(OBJ)fftserver.o $(OBJ)fftservintf.o $(OBJ)generaldata.o $(OBJ)generalfit.o $(OBJ)imageop.o $(OBJ)integ.o $(OBJ)matxop.o $(OBJ)median.o $(OBJ)nbmath.o $(OBJ)nbrandom.o $(OBJ)nbtri.o $(OBJ)ntoolsinit.o $(OBJ)ntupintf.o $(OBJ)objfitter.o $(OBJ)perandom.o $(OBJ)poly.o $(OBJ)rk4cdifeq.o $(OBJ)rzimage.o $(OBJ)simplesort.o $(OBJ)tabmath.o $(OBJ)utils.o
 	$(ARCXX) $(ARCXXFLAGS) $@ $?
 ifeq ($(CXX),cxx)
-	$(CXX) $? $(CPPFLAGS) $(CXXFLAGS) -L$(LIB) -lNTools -lSysTools -o $(OBJ)xx.x -Hf
+	$(CXX) $? $(CPPFLAGS) $(CXXFLAGS) -o $(OBJ)xx.x -Hf
 endif 
  
@@ -16,26 +16,20 @@
  $(INC)pexceptions.h cimage.h rzimage.h \
  rzvect.h datatypes.h $(INC)ppersist.h \
- $(INC)md5.h dvlist.h \
+ $(INC)gnumd5.h \
+ $(INC)dvlist.h \
  $(INC)objfio.h \
  $(INC)anydataobj.h fct1dfit.h generalfit.h \
- tvector.h tmatrix.h $(INC)ndatablock.h \
- generaldata.h ntupintf.h poly.h peida.h utils.h fmath.h histos.h \
- nbconst.h
+ $(INC)tvector.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h generaldata.h ntupintf.h \
+ poly.h peida.h utils.h fmath.h \
+ $(INC)histos.h \
+ $(INC)peida.h nbconst.h
 $(OBJ)cspline.o: cspline.cc $(INC)machdefs.h \
  $(INC)pclassids.h nbtri.h cspline.h \
  $(INC)pexceptions.h
-$(OBJ)cvector.o: cvector.cc $(INC)machdefs.h \
- $(INC)pclassids.h cvector.h matrix.h \
- peida.h utils.h $(INC)perrors.h \
- $(INC)pexceptions.h fmath.h \
- $(INC)anydataobj.h \
- $(INC)ppersist.h \
- $(INC)md5.h generalfit.h tvector.h \
- tmatrix.h $(INC)ndatablock.h generaldata.h \
- $(INC)objfio.h ntupintf.h poly.h
-$(OBJ)datacards.o: datacards.cc $(INC)machdefs.h \
- $(INC)pclassids.h datacards.h peida.h \
- utils.h $(INC)perrors.h \
- $(INC)pexceptions.h fmath.h
 $(OBJ)datatypes.o: datatypes.cc datatypes.h \
  $(INC)machdefs.h \
@@ -47,175 +41,257 @@
 $(OBJ)difeq.o: difeq.cc difeq.h $(INC)machdefs.h \
  $(INC)pclassids.h \
- $(INC)pexceptions.h tvector.h tmatrix.h \
- $(INC)ppersist.h \
- $(INC)md5.h \
- $(INC)anydataobj.h \
- $(INC)ndatablock.h \
+ $(INC)pexceptions.h \
+ $(INC)tvector.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)anydataobj.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)ppersist.h \
+ $(INC)gnumd5.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h \
  $(INC)ctimer.h
-$(OBJ)dvlist.o: dvlist.cc $(INC)machdefs.h \
- $(INC)pclassids.h dvlist.h \
- $(INC)objfio.h \
- $(INC)anydataobj.h \
- $(INC)ppersist.h \
- $(INC)pexceptions.h \
- $(INC)md5.h strutil.h
 $(OBJ)dynccd.o: dynccd.cc $(INC)machdefs.h \
  $(INC)pclassids.h fmath.h perandom.h \
- histos.h $(INC)objfio.h \
- $(INC)anydataobj.h \
- $(INC)ppersist.h \
- $(INC)pexceptions.h \
- $(INC)md5.h peida.h utils.h \
- $(INC)perrors.h tvector.h tmatrix.h \
- $(INC)ndatablock.h nbrandom.h cimage.h \
- rzimage.h rzvect.h datatypes.h dvlist.h dynccd.h
+ $(INC)histos.h \
+ $(INC)objfio.h \
+ $(INC)anydataobj.h \
+ $(INC)ppersist.h \
+ $(INC)pexceptions.h \
+ $(INC)gnumd5.h \
+ $(INC)peida.h \
+ $(INC)utils.h \
+ $(INC)perrors.h \
+ $(INC)fmath.h \
+ $(INC)tvector.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)dvlist.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h nbrandom.h cimage.h \
+ rzimage.h rzvect.h datatypes.h dynccd.h
 $(OBJ)fct1dfit.o: fct1dfit.cc $(INC)machdefs.h \
  $(INC)pclassids.h fct1dfit.h generalfit.h \
- $(INC)pexceptions.h tvector.h tmatrix.h \
- $(INC)ppersist.h \
- $(INC)md5.h \
- $(INC)anydataobj.h \
- $(INC)ndatablock.h generaldata.h \
- $(INC)objfio.h ntupintf.h poly.h peida.h \
- utils.h $(INC)perrors.h fmath.h nbconst.h \
- tabmath.h
+ $(INC)pexceptions.h \
+ $(INC)tvector.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)anydataobj.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)ppersist.h \
+ $(INC)gnumd5.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h generaldata.h ntupintf.h \
+ poly.h peida.h utils.h $(INC)perrors.h \
+ fmath.h nbconst.h tabmath.h
 $(OBJ)fct2dfit.o: fct2dfit.cc $(INC)machdefs.h \
  $(INC)pclassids.h fct2dfit.h generalfit.h \
- $(INC)pexceptions.h tvector.h tmatrix.h \
- $(INC)ppersist.h \
- $(INC)md5.h \
- $(INC)anydataobj.h \
- $(INC)ndatablock.h generaldata.h \
- $(INC)objfio.h ntupintf.h poly.h peida.h \
- utils.h $(INC)perrors.h fmath.h nbconst.h \
- tabmath.h simps2d.h
-$(OBJ)fftserver.o: fftserver.cc fftserver.h tvector.h tmatrix.h \
- $(INC)machdefs.h \
- $(INC)pclassids.h \
- $(INC)ppersist.h \
- $(INC)pexceptions.h \
- $(INC)md5.h \
- $(INC)anydataobj.h \
- $(INC)ndatablock.h
+ $(INC)pexceptions.h \
+ $(INC)tvector.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)anydataobj.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)ppersist.h \
+ $(INC)gnumd5.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h generaldata.h ntupintf.h \
+ poly.h peida.h utils.h $(INC)perrors.h \
+ fmath.h nbconst.h tabmath.h simps2d.h
+$(OBJ)fftmserver.o: fftmserver.cc fftmserver.h fftservintf.h \
+ $(INC)machdefs.h \
+ $(INC)pclassids.h \
+ $(INC)pexceptions.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)anydataobj.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)ppersist.h \
+ $(INC)gnumd5.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h \
+ $(INC)tvector.h fftmayer.h
+$(OBJ)fftpserver.o: fftpserver.cc fftpserver.h fftservintf.h \
+ $(INC)machdefs.h \
+ $(INC)pclassids.h \
+ $(INC)pexceptions.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)anydataobj.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)ppersist.h \
+ $(INC)gnumd5.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h \
+ $(INC)tvector.h fftpackc.h
+$(OBJ)fftserver.o: fftserver.cc fftserver.h \
+ $(INC)tvector.h \
+ $(INC)tmatrix.h \
+ $(INC)machdefs.h \
+ $(INC)pclassids.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)anydataobj.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)ppersist.h \
+ $(INC)pexceptions.h \
+ $(INC)gnumd5.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h
+$(OBJ)fftservintf.o: fftservintf.cc fftservintf.h \
+ $(INC)machdefs.h \
+ $(INC)pclassids.h \
+ $(INC)pexceptions.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)anydataobj.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)ppersist.h \
+ $(INC)gnumd5.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h \
+ $(INC)tvector.h
 $(OBJ)generaldata.o: generaldata.cc \
  $(INC)machdefs.h \
- $(INC)pclassids.h strutil.h nbtri.h \
- generalfit.h $(INC)pexceptions.h tvector.h \
- tmatrix.h $(INC)ppersist.h \
- $(INC)md5.h \
- $(INC)anydataobj.h \
- $(INC)ndatablock.h generaldata.h \
- $(INC)objfio.h ntupintf.h poly.h peida.h \
- utils.h $(INC)perrors.h fmath.h
+ $(INC)pclassids.h \
+ $(INC)strutil.h nbtri.h generalfit.h \
+ $(INC)pexceptions.h \
+ $(INC)tvector.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)anydataobj.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)ppersist.h \
+ $(INC)gnumd5.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h generaldata.h ntupintf.h \
+ poly.h peida.h utils.h $(INC)perrors.h \
+ fmath.h
 $(OBJ)generalfit.o: generalfit.cc $(INC)machdefs.h \
  $(INC)pclassids.h \
- $(INC)pexceptions.h generalfit.h tvector.h \
- tmatrix.h $(INC)ppersist.h \
- $(INC)md5.h \
- $(INC)anydataobj.h \
- $(INC)ndatablock.h generaldata.h \
- $(INC)objfio.h ntupintf.h poly.h peida.h \
- utils.h $(INC)perrors.h fmath.h
-$(OBJ)hisprof.o: hisprof.cc $(INC)machdefs.h \
- $(INC)pclassids.h hisprof.h peida.h utils.h \
- $(INC)perrors.h \
- $(INC)pexceptions.h fmath.h tvector.h \
- tmatrix.h $(INC)ppersist.h \
- $(INC)md5.h \
- $(INC)anydataobj.h \
- $(INC)ndatablock.h histos.h \
- $(INC)objfio.h
-$(OBJ)histos.o: histos.cc $(INC)machdefs.h \
- $(INC)pclassids.h histos.h \
- $(INC)objfio.h \
- $(INC)anydataobj.h \
- $(INC)ppersist.h \
- $(INC)pexceptions.h \
- $(INC)md5.h peida.h utils.h \
- $(INC)perrors.h fmath.h tvector.h tmatrix.h \
- $(INC)ndatablock.h poly.h strutil.h \
- generalfit.h generaldata.h ntupintf.h
-$(OBJ)histos2.o: histos2.cc $(INC)machdefs.h \
- $(INC)pclassids.h histos2.h peida.h utils.h \
- $(INC)perrors.h \
- $(INC)pexceptions.h fmath.h histos.h \
- $(INC)objfio.h \
- $(INC)anydataobj.h \
- $(INC)ppersist.h \
- $(INC)md5.h tvector.h tmatrix.h \
- $(INC)ndatablock.h generalfit.h \
- generaldata.h ntupintf.h poly.h
+ $(INC)pexceptions.h generalfit.h \
+ $(INC)tvector.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)anydataobj.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)ppersist.h \
+ $(INC)gnumd5.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h generaldata.h ntupintf.h \
+ poly.h peida.h utils.h $(INC)perrors.h \
+ fmath.h $(INC)sopemtx.h
 $(OBJ)imageop.o: imageop.cc $(INC)machdefs.h \
  $(INC)pclassids.h simplesort.h peida.h \
  utils.h $(INC)perrors.h \
  $(INC)pexceptions.h fmath.h nbmath.h \
- histos.h $(INC)objfio.h \
- $(INC)anydataobj.h \
- $(INC)ppersist.h \
- $(INC)md5.h tvector.h tmatrix.h \
- $(INC)ndatablock.h datatypes.h imageop.h \
- cimage.h rzimage.h rzvect.h dvlist.h cspline.h dynccd.h nbtri.h
+ $(INC)smathconst.h \
+ $(INC)histos.h \
+ $(INC)objfio.h \
+ $(INC)anydataobj.h \
+ $(INC)ppersist.h \
+ $(INC)gnumd5.h \
+ $(INC)peida.h \
+ $(INC)tvector.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)dvlist.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h datatypes.h imageop.h \
+ cimage.h rzimage.h rzvect.h cspline.h dynccd.h nbtri.h
 $(OBJ)integ.o: integ.cc integ.h $(INC)machdefs.h \
  $(INC)pclassids.h \
- $(INC)pexceptions.h generalfit.h tvector.h \
- tmatrix.h $(INC)ppersist.h \
- $(INC)md5.h \
- $(INC)anydataobj.h \
- $(INC)ndatablock.h generaldata.h \
- $(INC)objfio.h ntupintf.h poly.h peida.h \
- utils.h $(INC)perrors.h fmath.h
-$(OBJ)linfit.o: linfit.cc $(INC)machdefs.h \
- $(INC)pclassids.h peida.h utils.h \
- $(INC)perrors.h \
- $(INC)pexceptions.h fmath.h linfit.h \
- tvector.h tmatrix.h $(INC)ppersist.h \
- $(INC)md5.h \
- $(INC)anydataobj.h \
- $(INC)ndatablock.h
-$(OBJ)matrix.o: matrix.cc $(INC)machdefs.h \
- $(INC)pclassids.h peida.h utils.h \
- $(INC)perrors.h \
- $(INC)pexceptions.h fmath.h matrix.h \
- $(INC)anydataobj.h \
- $(INC)ppersist.h \
- $(INC)md5.h cvector.h generalfit.h \
- tvector.h tmatrix.h $(INC)ndatablock.h \
- generaldata.h $(INC)objfio.h ntupintf.h \
- poly.h
+ $(INC)pexceptions.h generalfit.h \
+ $(INC)tvector.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)anydataobj.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)ppersist.h \
+ $(INC)gnumd5.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h generaldata.h ntupintf.h \
+ poly.h peida.h utils.h $(INC)perrors.h \
+ fmath.h
 $(OBJ)median.o: median.cc
+$(OBJ)ntoolsinit.o: ntoolsinit.cc $(INC)machdefs.h \
+ $(INC)pclassids.h ntoolsinit.h \
+ $(INC)tarrinit.h \
+ $(INC)sophyainit.h poly.h \
+ $(INC)objfio.h \
+ $(INC)anydataobj.h \
+ $(INC)ppersist.h \
+ $(INC)pexceptions.h \
+ $(INC)gnumd5.h peida.h utils.h \
+ $(INC)perrors.h fmath.h \
+ $(INC)tvector.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)dvlist.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h generaldata.h ntupintf.h \
+ cimage.h rzimage.h rzvect.h datatypes.h tabmath.h nbconst.h dates.h \
+ datime.h
 $(OBJ)ntupintf.o: ntupintf.cc ntupintf.h \
  $(INC)machdefs.h \
  $(INC)pclassids.h
-$(OBJ)ntuple.o: ntuple.cc strutil.h \
- $(INC)perrors.h \
- $(INC)pexceptions.h \
- $(INC)machdefs.h \
- $(INC)pclassids.h ntuple.h \
- $(INC)objfio.h \
- $(INC)anydataobj.h \
- $(INC)ppersist.h \
- $(INC)md5.h ntupintf.h dvlist.h
-$(OBJ)outilsinit.o: outilsinit.cc outilsinit.h \
- $(INC)peidainit.h \
- $(INC)machdefs.h \
- $(INC)pclassids.h matrix.h peida.h utils.h \
- $(INC)perrors.h \
- $(INC)pexceptions.h fmath.h \
- $(INC)anydataobj.h \
- $(INC)ppersist.h \
- $(INC)md5.h cvector.h poly.h \
- $(INC)objfio.h tvector.h tmatrix.h \
- $(INC)ndatablock.h dvlist.h histos.h \
- histos2.h hisprof.h ntuple.h ntupintf.h generaldata.h cimage.h \
- rzimage.h rzvect.h datatypes.h tabmath.h nbconst.h dates.h datime.h
+$(OBJ)objfitter.o: objfitter.cc objfitter.h \
+ $(INC)machdefs.h \
+ $(INC)pclassids.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)anydataobj.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)ppersist.h \
+ $(INC)pexceptions.h \
+ $(INC)gnumd5.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h \
+ $(INC)tvector.h generalfit.h generaldata.h \
+ ntupintf.h poly.h peida.h utils.h \
+ $(INC)perrors.h fmath.h
 $(OBJ)perandom.o: perandom.cc $(INC)machdefs.h \
  $(INC)pclassids.h \
- $(INC)pexceptions.h perandom.h histos.h \
- $(INC)objfio.h \
- $(INC)anydataobj.h \
- $(INC)ppersist.h \
- $(INC)md5.h peida.h utils.h \
- $(INC)perrors.h fmath.h tvector.h tmatrix.h \
- $(INC)ndatablock.h nbrandom.h pemath.h
+ $(INC)pexceptions.h perandom.h \
+ $(INC)histos.h \
+ $(INC)objfio.h \
+ $(INC)anydataobj.h \
+ $(INC)ppersist.h \
+ $(INC)gnumd5.h \
+ $(INC)peida.h \
+ $(INC)utils.h \
+ $(INC)perrors.h \
+ $(INC)fmath.h \
+ $(INC)tvector.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)dvlist.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h nbrandom.h pemath.h
 $(OBJ)poly.o: poly.cc $(INC)machdefs.h \
  $(INC)pclassids.h poly.h \
@@ -224,14 +300,29 @@
  $(INC)ppersist.h \
  $(INC)pexceptions.h \
- $(INC)md5.h peida.h utils.h \
- $(INC)perrors.h fmath.h tvector.h tmatrix.h \
- $(INC)ndatablock.h linfit.h
+ $(INC)gnumd5.h peida.h utils.h \
+ $(INC)perrors.h fmath.h \
+ $(INC)tvector.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)dvlist.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h linfit.h \
+ $(INC)sopemtx.h \
+ $(INC)fioarr.h
 $(OBJ)rk4cdifeq.o: rk4cdifeq.cc $(INC)machdefs.h \
  $(INC)pclassids.h rk4cdifeq.h difeq.h \
- $(INC)pexceptions.h tvector.h tmatrix.h \
- $(INC)ppersist.h \
- $(INC)md5.h \
- $(INC)anydataobj.h \
- $(INC)ndatablock.h \
+ $(INC)pexceptions.h \
+ $(INC)tvector.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)anydataobj.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)ppersist.h \
+ $(INC)gnumd5.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h \
  $(INC)ctimer.h
 $(OBJ)rzimage.o: rzimage.cc $(INC)machdefs.h \
@@ -240,9 +331,15 @@
  $(INC)perrors.h datatypes.h \
  $(INC)ppersist.h \
- $(INC)md5.h dvlist.h \
- $(INC)objfio.h \
- $(INC)anydataobj.h generalfit.h tvector.h \
- tmatrix.h $(INC)ndatablock.h generaldata.h \
- ntupintf.h poly.h peida.h utils.h fmath.h
+ $(INC)gnumd5.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)anydataobj.h generalfit.h \
+ $(INC)tvector.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h generaldata.h ntupintf.h \
+ poly.h peida.h utils.h fmath.h
 $(OBJ)simplesort.o: simplesort.cc $(INC)machdefs.h \
  $(INC)pclassids.h simplesort.h peida.h \
@@ -253,37 +350,22 @@
  $(INC)perrors.h \
  $(INC)pexceptions.h fmath.h nbconst.h
-$(OBJ)tmatrix.o: tmatrix.cc $(INC)machdefs.h \
- $(INC)pclassids.h \
- $(INC)pexceptions.h tmatrix.h \
- $(INC)ppersist.h \
- $(INC)md5.h \
- $(INC)anydataobj.h \
- $(INC)ndatablock.h \
- $(INC)objfio.h generalfit.h tvector.h \
- generaldata.h ntupintf.h poly.h peida.h utils.h \
- $(INC)perrors.h fmath.h
-$(OBJ)tvector.o: tvector.cc $(INC)machdefs.h \
- $(INC)pclassids.h \
- $(INC)pexceptions.h tvector.h tmatrix.h \
- $(INC)ppersist.h \
- $(INC)md5.h \
- $(INC)anydataobj.h \
- $(INC)ndatablock.h \
- $(INC)objfio.h generalfit.h generaldata.h \
- ntupintf.h poly.h peida.h utils.h \
- $(INC)perrors.h fmath.h
 $(OBJ)utils.o: utils.cc $(INC)machdefs.h \
  $(INC)pclassids.h utils.h \
  $(INC)pexceptions.h
 $(OBJ)datime.o: datime.c $(INC)machdefs.h \
- strutil.h nbconst.h datime.h
+ $(INC)strutil.h nbconst.h datime.h
+$(OBJ)fftmayer_r4.o: fftmayer_r4.c fftmayer.h \
+ $(INC)machdefs.h trigtbl.h
+$(OBJ)fftmayer_r8.o: fftmayer_r8.c fftmayer.h \
+ $(INC)machdefs.h trigtbl.h
 $(OBJ)fftpackc.o: fftpackc.c fftpackc.h \
  $(INC)machdefs.h
 $(OBJ)matxop.o: matxop.c matxop.h nbmath.h \
- $(INC)machdefs.h
+ $(INC)machdefs.h \
+ $(INC)smathconst.h
 $(OBJ)nbmath.o: nbmath.c nbmath.h $(INC)machdefs.h \
- matxop.h nbinteg.h nbtri.h
+ $(INC)smathconst.h matxop.h nbinteg.h \
+ nbtri.h
 $(OBJ)nbrandom.o: nbrandom.c $(INC)machdefs.h \
- nbmath.h nbrandom.h
+ nbmath.h $(INC)smathconst.h nbrandom.h
 $(OBJ)nbtri.o: nbtri.c nbtri.h $(INC)machdefs.h
-$(OBJ)strutil.o: strutil.c strutil.h
Index: trunk/SophyaLib/NTools/objlist.list
===================================================================
--- trunk/SophyaLib/NTools/objlist.list	(revision 805)
+++ trunk/SophyaLib/NTools/objlist.list	(revision 824)
@@ -1,25 +1,22 @@
 cimage.o
 cspline.o
-cvector.o
-datacards.o
 datatypes.o
 dates.o
 datime.o
 difeq.o
-dvlist.o
 dynccd.o
 fct1dfit.o
 fct2dfit.o
+fftmayer_r4.o
+fftmayer_r8.o
+fftmserver.o
 fftpackc.o
+fftpserver.o
 fftserver.o
+fftservintf.o
 generaldata.o
 generalfit.o
-hisprof.o
-histos.o
-histos2.o
 imageop.o
 integ.o
-linfit.o
-matrix.o
 matxop.o
 median.o
@@ -27,7 +24,7 @@
 nbrandom.o
 nbtri.o
+ntoolsinit.o
 ntupintf.o
-ntuple.o
-outilsinit.o
+objfitter.o
 perandom.o
 poly.o
@@ -35,7 +32,4 @@
 rzimage.o
 simplesort.o
-strutil.o
 tabmath.o
-tmatrix.o
-tvector.o
 utils.o