Index: trunk/SophyaLib/Samba/alm.cc
===================================================================
--- trunk/SophyaLib/Samba/alm.cc	(revision 824)
+++ trunk/SophyaLib/Samba/alm.cc	(revision 833)
@@ -29,5 +29,6 @@
   //    --- smoothes the initial power spectrum ---
   TVector<T> cl=clin;
-  for (int l=0;l<n_l;l++)
+  int l;
+  for (l=0;l<n_l;l++)
     {
       r_8 gauss=exp(-l*(l+1.)*sig_smooth*sig_smooth);
@@ -39,5 +40,5 @@
   r_8 hsqrt2 = 1.0 / Rac2;
 
-  for (int l=0;l<n_l;l++)
+  for (l=0;l<n_l;l++)
     {
       T rms=sqrt(cl(l));
Index: trunk/SophyaLib/Samba/sphericaltransformserver.cc
===================================================================
--- trunk/SophyaLib/Samba/sphericaltransformserver.cc	(revision 824)
+++ trunk/SophyaLib/Samba/sphericaltransformserver.cc	(revision 833)
@@ -80,5 +80,6 @@
       LambdaLMBuilder lb(theta,nlmax,nmmax);
       //  somme sur m de 0 a l'infini
-      for (int m = 0; m <= nmmax; m++)
+      int m;
+      for (m = 0; m <= nmmax; m++)
 	{
 	  //  somme sur l de m a l'infini
@@ -104,5 +105,5 @@
     //        obtains the negative m of b(m,theta) (= complex conjugate)
 
-      for (int m=1;m<=nmmax;m++)
+      for (m=1;m<=nmmax;m++)
 	{
 	  //compiler doesn't have conj()
@@ -169,5 +170,6 @@
 
   for (int kk=0; kk<bw.NElts(); kk++) bw(kk)=(T)0.;
-  for (int m=-b_m.Mmax();m<=-1;m++)
+  int m;
+  for (m=-b_m.Mmax();m<=-1;m++)
     {
       int maux=m;
@@ -177,5 +179,5 @@
       bw(iw) += b_m(m) * complex<T>( (T)cos(aux),(T)sin(aux) )  ;
     }
-  for (int m=0;m<=b_m.Mmax();m++)
+  for (m=0;m<=b_m.Mmax();m++)
     {
       //      int iw=((m % nph) +nph) % nph; //between 0 and nph = m'
@@ -248,5 +250,6 @@
 
   for (int kk=0; kk<bw.NElts(); kk++) bw(kk)=(T)0.;
-  for (int m=-b_m.Mmax();m<=-1;m++)
+  int m;
+  for (m=-b_m.Mmax();m<=-1;m++)
     {
       int maux=m;
@@ -256,5 +259,5 @@
       bw(iw) += b_m(m) * complex<T>( (T)cos(aux),(T)sin(aux) )  ;
     }
-  for (int m=0;m<=b_m.Mmax();m++)
+  for (m=0;m<=b_m.Mmax();m++)
     {
       //      int iw=((m % nph) +nph) % nph; //between 0 and nph = m'
@@ -365,6 +368,7 @@
 
   int im_max=min(nph,nmmax+1);
-  for (int i=0;i< dataout.NElts();i++) dataout(i)=complex<T>((T)0.,(T)0.);
-  for (int i=0;i<im_max;i++) dataout(i)=transformedData(i);
+  int i;
+  for (i=0;i< dataout.NElts();i++) dataout(i)=complex<T>((T)0.,(T)0.);
+  for (i=0;i<im_max;i++) dataout(i)=transformedData(i);
 
 
@@ -373,5 +377,5 @@
   //  }
   for (int kk=nph; kk<dataout.NElts(); kk++) dataout(kk)=dataout(kk%nph);
-  for (int i = 0;i <dataout.NElts();i++){
+  for (i = 0;i <dataout.NElts();i++){
     dataout(i)*= (complex<T>)(complex<double>(cos(-i*phi0),sin(-i*phi0)));
   }
@@ -415,5 +419,6 @@
   int sizeOfTransformToGet = min(transformedData.NElts(),nmmax+1);
   //  int im_max=min(transformedData.NElts()-1,nmmax);
-  for (int i=0;i<sizeOfTransformToGet;i++) dataout(i)=transformedData(i);
+  int i;
+  for (i=0;i<sizeOfTransformToGet;i++) dataout(i)=transformedData(i);
 
 
@@ -422,5 +427,5 @@
   if (sizeOfTransformToGet == (transformedData.NElts()))
     {
-      for (int i=transformedData.NElts(); i<min(nph,dataout.NElts()); i++)
+      for (i=transformedData.NElts(); i<min(nph,dataout.NElts()); i++)
 	{
 
@@ -434,5 +439,5 @@
 	}
     }
-  for (int i = 0;i <dataout.NElts();i++){
+  for (i = 0;i <dataout.NElts();i++){
     dataout(i)*= (complex<T>)(complex<double>(cos(-i*phi0),sin(-i*phi0)));
   }
@@ -640,10 +645,10 @@
       phasem(i)=0; 
     }
-
-  for(int kk=0; kk<nph; kk++) datain(kk)=complex<T>(dataq(kk),datau(kk));
+  int kk;
+  for(kk=0; kk<nph; kk++) datain(kk)=complex<T>(dataq(kk),datau(kk));
 
   phasep = CFromFourierAnalysis(nmmax,datain,phi0); 
 
-  for(int kk=0; kk<nph; kk++) datain(kk)=complex<T>(dataq(kk),-datau(kk));
+  for(kk=0; kk<nph; kk++) datain(kk)=complex<T>(dataq(kk),-datau(kk));
   phasem = CFromFourierAnalysis(nmmax,datain,phi0); 
   LambdaPMBuilder lpmb(theta,nlmax,nmmax);
@@ -695,5 +700,6 @@
       //      LambdaPMBuilder lpmb(theta,nlmax,nmmax);
       r_8 sqr2inv=1/Rac2;
-      for (int m = 0; m <= nmmax; m++)
+      int m;
+      for (m = 0; m <= nmmax; m++)
 	{
 	  r_8 lambda_w=0.;
@@ -718,5 +724,5 @@
 	}
       //        obtains the negative m of b(m,theta) (= complex conjugate)
-      for (int m=1;m<=nmmax;m++)
+      for (m=1;m<=nmmax;m++)
 	{
 	  b_m_theta_q(-m) = conj(b_m_theta_q(m));
@@ -764,5 +770,6 @@
 
       LambdaPMBuilder lpmb(theta,nlmax,nmmax);
-      for (int m = 0; m <= nmmax; m++)
+      int m;
+      for (m = 0; m <= nmmax; m++)
 	{
 	  r_8 lambda_p=0.;
@@ -784,5 +791,5 @@
       
       //        obtains the negative m of b(m,theta) (= complex conjugate)
-      for (int m=1;m<=nmmax;m++)
+      for (m=1;m<=nmmax;m++)
 	{
 	  b_m_theta_p(-m) = conj(b_m_theta_m(m));