Index: trunk/DocHFI_L2/wbsl2.tex
===================================================================
--- trunk/DocHFI_L2/wbsl2.tex	(revision 811)
+++ trunk/DocHFI_L2/wbsl2.tex	(revision 845)
@@ -1,7 +1,10 @@
-\documentclass[twoside,12pt]{article}
+\documentclass[twoside,11pt]{article}
 %  Package standard : Utilisation de caracteres accentues, mode francais et graphique
 \usepackage[latin1]{inputenc}
 \usepackage[T1]{fontenc}
+\usepackage{babel}
 \usepackage{graphicx}
+% package a mettre pour faire du pdf
+\usepackage{palatino}
 
 %  Extension de symboles mathematiques
@@ -24,5 +27,6 @@
 \begin{titlepage}
 \vspace{1cm}
-\rule{110 mm}{0.5 mm}\makebox[50 mm]{\bf Planck HFI L2}
+\makebox[30mm][c]{\includegraphics[width=3cm]{hfi_icon_vsmall.eps}}
+\raisebox{12mm}{\rule{80 mm}{0.5 mm}\makebox[50 mm]{\bf Planck HFI L2}}
 \vspace{2cm}
 \begin{center}
@@ -30,12 +34,19 @@
 {\LARGE \bf 
 Planck HFI L2 \\ 
-WBS - PBS
+Work Breakdown Structure \\
+Package Breakdown Structure
 }
+
 \par \renewcommand{\baselinestretch}{1.0} \normalsize
-\vspace{5 cm}
+\vspace{2 cm}
 \begin{tabular}{ll}
-{R. Ansari} & {\tt ansari@lal.in2p3.fr} \\
-{C. Mercier} & {\tt Claude.Mercier@ias.fr} \\
-{J.F. Sygnet} & {\tt Jean-Francois.Sygnet@ias.fr} \\
+R. Ansari & LAL \\ % & {\tt ansari@lal.in2p3.fr} \\
+I.J. Grivell  & ICSTM \\ 
+R.G. Mann  &  IfA, Edinburgh \\ 
+C. Mercier & IAS \\ % & {\tt Claude.Mercier@ias.fr} \\
+M. Rowan-Robinson  & ICSTM \\ 
+S. Serjeant  & ICSTM \\ 
+J.F. Sygnet & IAS \\ % {\tt Jean-Francois.Sygnet@ias.fr} \\
+
 % {É. Aubourg} & {\tt aubourg@hep.saclay.cea.fr} \\
 % {É. Lesquoy} & {\tt lesquoy@hep.saclay.cea.fr} \\
@@ -46,8 +57,22 @@
 \vfill
 \hfill 
-% \includegraphics[width=4cm]{Fig/hfi_icon_vsmall.eps}
 \framebox[\textwidth]{\hspace{0.5cm} \bf Planck HFI Level 2 
-\hspace{1cm} \today }
+\hspace{1cm} \today } \\
 \end{titlepage}
+
+\vspace*{1cm}
+\begin{center}
+\mbox{
+\rule{50 mm}{0.6 mm} \makebox[60 mm]{\bf Revision history} \rule{50 mm}{0.6 mm} }
+\end{center}
+\vspace{2 mm}
+\begin{itemize}
+\item Version 1.0 (February 2000 - CVS version 1.1) \\
+Draft version presented at the HFI consortium meeting 
+\item Version 1.1 (April 2000 - CVS version 1.2) \\
+Draft updated using the document prepared at ISCTM and IfA (Edinburgh)
+\end{itemize}
+
+\newpage
 
 \tableofcontents
@@ -56,13 +81,24 @@
 % \tableofcontents
 
-\section*{HFI L2 processing software packages}
+\section{Introduction}
 This document contains a preliminary version a the 
 Work Breakdown Structure (WBS), Package Breakdown Structure 
 (PBS) for Planck-HFI Level 2 data processing.
 
-The different packages are listed here. It should be noted that
-all packages should be compliant with the general software 
-architecture and use the services of the corresponding 
-support modules (\gph{428}). \\
+The Level 2 activity of the HFI Data Processing Centre (DPC) 
+is divided between the Paris-Orsay-Saclay Data Analysis Centre 
+(POSDAC) and the London Planck Analysis Centre (LPAC).
+POSDAC will run the Level 2 data processing pipeline and have overall 
+responsibility for the collaborative work involved in its 
+design and implementation. LPAC will a major role for in the 
+activities that iterate and overlap between Level 2 
+and Level 3 (for which the Cambridge Planck Analysis Centre, 
+CPAC, plays the role analogous to POSDAC at Level 2)
+
+\section{HFI L2 processing software packages}
+The Level 2 workpackages are listed below, with a numbering 
+scheme derived from that in the 
+{\it HFI Science Implementation Plan (SIP: draft of 19/11/99) }.
+All packages should be compliant with the general software architecture and use the services of the corresponding support modules (\gph{428}).
 
 \begin{itemize}
@@ -78,13 +114,18 @@
 \end{itemize}
 
-Other related packages:
-\begin{itemize}
-\item[]\gph{320} Hardware, network and related software procurement
-and management
-\item[]\gph{140} Project management.
+In addition to the specific Level 2 workpackages, the following are 
+also related to Level 2 data processing:
+
+\begin{itemize}
+\item[]\gph{320} infrastructure procurement and maintenance (POSDAC)
+\item[]\gph{360} infrastructure procurement and maintenance (LPAC)
+\item[]\gph{140} Project management (POSDAC)
+\item[]\gph{180} Project management (LPAC)
 \end{itemize}
 
 The table below shows a very preliminary cost estimate in
-FTE-MY (Full Time Equivalent Man Year) for each package. \\
+FTE-MY (Full Time Equivalent Man Years) for each package. \\
+
+\begin{table}
 \begin{center}
 \begin{tabular}[h]{|c|c||c|c|}
@@ -106,22 +147,31 @@
 %
 \hline 
-\ngph{320}     &   5     & \ngph{140}     &   5     \\
+\ngph{320}     &   3     & \ngph{140}     &   4     \\
+\ngph{360}     &   2     & \ngph{180}     &   1     \\
 \hline \hline
 \multicolumn{2}{c}{\bf Total}          &   \multicolumn{2}{c}{\bf 110 + ?} \\
 \hline 
 \end{tabular}
-% \caption{Preliminary cost estimate}
 \end{center}
-
-
-\newpage
+\caption{Preliminary estimate of staff effort 
+(in Full Time Equivalent Man-Years FTE-MY)}
+\end{table}
+
 
 \section{GPH421: RTA/QLA Real Time Assesment, Quick Look Analysis}
+\begin{itemize}
+\item[]\gph{421.1} Quick look analysis
+\item[]\gph{421.2} Evaluation of instrument health
+\item[]\gph{421.1} Exchange of information with LFI 
+of mission/spacecraft/payload-dependent effects common 
+to both instruments
+\end{itemize}
 
 \section{GPH422: TOI  processing}
 
 This package contains all the processing which has to be 
-perfomed on TOI's (Time Ordered Information ) either single detector, or
-multpile detector, single frequency set of TOI's.
+perfomed on TOI's (Time Ordered Information ) for either a 
+single-detector or multpile-detector, single-frequency set 
+of TOI's.
 
 \begin{itemize}
@@ -129,30 +179,47 @@
 \item[]\gph{422.1}  TOI statistical characterisation 
 \begin{itemize}
-\item Raw time-line statistical checks
-\item Noise statistic determination
-\item Low frequency drifts
+\item[]422.1.1 Raw time-line statistical checks
+\item[]422.1.2 Evaluation of noise components in TOI \\
+(including use of redundancy to produce independent coadds)
+\item[]422.1.3 Low frequency drifts
+\item[]422.1.4 Correlation of TOI with housekeeping data and various 
+coordinate systems to look for systematic trends
+\item[]422.1.5 correlation of TOI between channels to identify 
+cross-talk
 \end{itemize}
 
 \item[]\gph{422.2}  TOI filters
 \begin{itemize}
-\item Time domain filtering
-\item Fourier filtering
-\end{itemize}
-
-\item[]\gph{422.3}  Deglitching and source detection
-\begin{itemize}
-\item TOI deglitchers
-\item Point source detector
-\item Galaxy crossing detector
-\item CMB dipole finder 
+\item[]422.2.1 Time domain filtering
+\item[]422.2.2 Fourier filtering
+\end{itemize}
+
+\item[]\gph{422.3}  Deglitching and source extraction
+\begin{itemize}
+\item[]422.3.1 production of deglitched TOI, flagged to indicate cosmic
+ray hits etc.
+\item[]422.3.2 Point source detectors
+\item[]422.3.3 Galaxy crossing detector
+\item[]422.3.4 CMB dipole finder 
 \end{itemize}
 
 \item[]\gph{422.4}  Astrometric calibration \\
-Astrometric calibration using point sources and galaxy crossing.
-
-\item[]\gph{422.5}  Photometric calibration \\
-Photometric calibration, using extended sources (Galaxy)
-
-\item[]\gph{422.6}  Single pointing co-added rings \\
+Astrometric calibration using known point sources,
+bright sources from the ECSC and galaxy crossing in TOI.
+
+\item[]\gph{422.5}  Photometric calibration 
+\begin{itemize}
+\item[]422.5.1 extended-source photometric calibration using known 
+sources (Galaxy) and COBE/FIRAS data
+\item[]422.5.2 point-source photometric calibration using known sources
+\item[]422.5.3 reconstruction of beam pattern seen by each detector 
+from observations of bright 
+\end{itemize}
+
+\item[]\gph{422.6} reconstruction of beam pattern seen by each 
+detector from observations of bright point sources \gph{422.3.2}
+and galaxy crossing \gph{422.3.3}
+
+\item[]\gph{422.7}  Production of single pointing co-added rings 
  
 \item[]\gph{422.9}  Deliverables: Cleaned, calibrated TOI's : 
@@ -168,6 +235,7 @@
 \section{GPH423: Polarised TOI processing}
 
-\gph{423.1} I.Q,U reconstruction from detector signals 
-in polarized channels
+\gph{423.1} Additional TOI processing, as required to 
+reconstruct Stokes I,Q,U parameters from detector signals 
+in polarised channels.
 
 \section{GPH424: Simple 2-D map reconstruction}
@@ -180,23 +248,28 @@
 \gph{424} which must provide a global, optimal 2-D map 
 reconstruction with systematic effects assessment.
+
 \begin{itemize} 
-
 \item[]\gph{424.1} 1D $\rightarrow$ 2D Projector
-\item[]\gph{424.2} Systematic effects estimation, subtraction 
-\begin{itemize}
-\item Low frequency noise estimation
-\item far side lobe subtraction
-\item far side determination using moon/earth during transfer, 
+\item[]\gph{424.2} Estimation and subtraction of systematic effects  
+\begin{itemize}
+\item[]424.2.1 Low frequency noise estimation
+\item[]424.2.2 far side determination using moon/earth during  
 commissioning phases.
+\item[]424.2.3 far side lobe subtraction
+\item[]424.2.4 use of redundancy to produce independent maps for 
+assessment of noise contributions
 \end{itemize}
 
 \item[]\gph{424.3} Main lobe 
 \begin{itemize}
-\item Point source detection
-\item Main lobe reconstruction
-\end{itemize}
-
-
-\item[]\gph{424.4} Astrometric calibration
+\item[]424.3.1 supplementing source extraction from TOI with 
+use of sources selected from frequency maps
+\item[]424.3.2 reconstruction of beam pattern from maps using 
+known point and bright ECSC sources.
+\end{itemize}
+
+
+\item[]\gph{424.4} Astrometric calibration using known and 
+bright ECSC sources.
 \item[]\gph{424.5} Photometric calibration
 \item[]\gph{424.6} Postage stamp maps for compact sources
@@ -222,8 +295,8 @@
 \item[]\gph{425.9} Deliverables: Full sky maps \\
 \begin{itemize}
-\item Sky maps per frequency channels $map_\nu (\alpha, \delta) $
+\item Full sky maps for each frequency channels $map_\nu (\alpha, \delta) $
 \item Reprocessed, cleanead TOI's
-\item Lobe par detector and per frequency channel
-\item Systematics estimation 
+\item Beam patterns per detector and per frequency channel
+\item Estimation of systematics 
 \end{itemize} 
 
@@ -234,12 +307,12 @@
 This module, a extended version of \gph{425} has to take 
 into account specific constraints related to polarised TOI's
-and sky map recosntruction
-
-\begin{itemize}
-
-\item[]\gph{426.9} Deliverables: Full sky maps for each 
+and sky map reconstruction
+
+\begin{itemize}
+
+\item[]\gph{426.9} Deliverables: full sky maps for each 
 polarisation component (I,Q,U) \\
 \begin{itemize}
-\item Sky maps per frequency channels $map_\nu (\alpha, \delta) $
+\item Full sky maps for each frequency channels $map_\nu (\alpha, \delta) $
 for each component (I,Q,U)
 \item Reprocessed, cleanead TOI's for I,Q,U
@@ -259,6 +332,6 @@
 photometrically calibrated flux in each frequency band \\
 $$(\alpha, \delta)_i , F_i^\nu, i=1,..,N$$
-\item The corresponding local sky maps in each 
-frequency bands.
+\item Llocal sky maps in each frequency bands for areas 
+around all source positions.
 \item Related software and documentation
 \end{itemize} 
@@ -276,25 +349,29 @@
 \begin{itemize}
 
-\item[]\gph{428.1} General architecture
-
-\item[]\gph{428.2} TOI manipulation module
-
-\item[]\gph{428.3} Maps manipulation module (Full and local sky maps)
+\item[]\gph{428.1} Definition and construction of the software architecture
+
+\item[]\gph{428.2} Development and maintenance of TOI manipulation module
+(including diagnostics and display)
+
+\item[]\gph{428.3} Development and maintenance of maps manipulation module
+(including diagnostics and display of both full and local sky maps)
 
 \item[]\gph{428.4} Instrument and satellite representation 
 \begin{itemize}
-\item Focal plane geometry
-\item Detector's frequency response
-\item Main and secondary Lobes 
-\item Orbit and attitude
-\item Thermal model
-\end{itemize} 
-
-\item[]\gph{428.5} Standard numerical analysis tools
-\begin{itemize}
-\item Arrays (Matrix, Vectors, \ldots) and linear algebra
-\item Fourier analysis, Wavelet analysis
-\item Minimisation, optimisation
-\item Statistical analysis
+\item[]428.4.1 Focal plane geometry
+\item[]428.4.2 Detector's frequency response
+\item[]428.4.3 Main and secondary lobes
+\item[]428.4.4 Sampling and noise characteristics
+\item[]428.4.5 Orbit and attitude
+\item[]428.4.6 Thermal model
+\end{itemize} 
+
+\item[]\gph{428.5} Development/supply and maintenence 
+of standard numerical analysis tools
+\begin{itemize}
+\item[]428.5.1 Arrays (Matrix, Vectors, \ldots) and linear algebra
+\item[]428.5.2 Fourier analysis, Wavelet analysis
+\item[]428.5.3 Minimisation, optimisation
+\item[]428.5.4 Statistical analysis
 \end{itemize} 
 
@@ -310,8 +387,26 @@
 integration in the pipeline, as well as the 
 assessment of the overall quality of the delivered 
-data products is the responsibility of \gph{429}
-
-\begin{itemize}
- 
+data products is the responsibility of \gph{429}.
+The data quality validation activity includes iterative 
+work using Level 2 and 3 data products, and comparison of 
+HFI and LFI data for the common 100 GHz channel:
+for example, activity in this workpackage may influence the details 
+of how the Global polarised 2D map reconstruction of \gph{426} 
+is performed, leading to the changes in the deliverables 
+from that workpackage.
+\begin{itemize}
+\item[]\gph{429.1} Pipeline management
+\begin{itemize}
+\item[]429.1.1 management and construction of pipeline 
+modules and their interfaces 
+\item[]429.1.2 IDIS and DMC interface 
+\item[]429.1.2 Management of pipeline operations
+\end{itemize}
+\item[]\gph{429.2} Iterative study of systematic effects 
+(e.g. map striping, etc) involving both level 2 and level 3 products
+\item[]\gph{429.3} Combination, comparison and validation 
+of source catalogues derived from Levels 2 and 3 source extraction
+\item[]\gph{429.4} Comparison of TOI data and maps between 
+HFI and LFI for common 100GHz channel
 \item[]\gph{429.9} Deliverables: Full sky maps for each 
 polarisation component (I,Q,U) \\